; Variable Send/Recieve Module for Expander2 TI-92 Driver
; Written by Bryan Rittmeyer <bryanr@pair.com>
; Copyright (C) 1997-1999 Horizon Technologies
; http://horizon.pair.com/
;
; These are the real meat routines
; Routine to send a file and receive a file.
; Yep, got it working ;-)

send_file:
        bsr ClearMenu
        bsr get_fname                   ; Get a file handle from user
; filenm is the file name we are sending
        cmp.w #1,d1
        beq exit_input
        cmp.w #0,f_handle               ; Did we get a match?
        beq exit_fnf                    ; No, exit

; Finds first non-used page in serial flash EEPROM
find_free:
        move.w #0,page
        WriteStr #10,#100,#4,scand
        WriteStr #150,#100,#4,oftot
        bsr PutBusy
ff_loop:
        cmp.w #2048,page
        beq no_free
        move.w page,value+2
        bsr PrintVal
        WriteStr #100,#100,#4,buffer
;        move.w #1,numba
;        move.b #0,pstart
;        lea fbyte(PC),a0
;        move.l a0,table_addr
;        bsr get_sfe                     ; Get first 4 characters
;        move.b fbyte,value+3            ; Display the byte we got
;        bsr PrintVal
;        WriteStr #210,#100,#4,buffer
        move.w #1,numba                 ; Check to see what kind of page this is
        move.b #3,pstart
        lea fbyte(PC),a0
        move.l a0,table_addr
        bsr get_sfe
        cmp.b #$FF,fbyte                ; Is the byte a $FF?
        beq free_found                  ; If it is, we found the first free page!
;        cmp.b #67,fbyte                 ; This is the continuation of a file
;        beq check_next			; This is not needed, we calculate!
        move.w #8,numba                 ; Get filename of that page
        move.b #4,pstart
        lea buff2(PC),a0
        move.l a0,table_addr
        bsr get_sfe
;        WriteStr #10,#30,#4,filenm
;        WriteStr #150,#30,#4,buff2
        lea filenm(PC),a0
        lea buff2(PC),a1
        bsr cmp_eight
        cmp.w #1,d0			; Does the file already exist????
        beq already_on			; No - Go to next file
check_next:
	move.w #2,numba			; Get file size, put in size
        move.b #13,pstart
        lea size(PC),a0
        move.l a0,table_addr
        bsr get_sfe
	move.w size,d0
        cmp.w #249,d0                   ; Is file one page? if so, go to next p$
        ble skip_to_next
        sub.w #249,d0                   ; Subtract number of bytes on this page
        move.w d0,d2
        divu #260,d0                    ; Divide file size by 260
        move.w d0,d1
        mulu #260,d1                    ; Test to see if division was even
        cmp.w d1,d2                     ; If so, d1=d2
        beq dont_need_one_more
	addq.w #1,page
dont_need_one_more:
	add.w d0,page
skip_to_next:
        addq.w #1,page
        bra ff_loop

no_free:
        WriteStr #10,#80,#4,nospac      ;
        bsr PutPaused
        bra exit_dir                    ; Return to main menu

already_on:
        WriteStr #10,#80,#4,alexist
        bsr PutPaused
        bra exit_dir

free_found:
        move.w f_handle,d0
        handle_ptr d0,a0
        move.l a0,fileadr               ; File address
        move.w (a0),size                ; File size

        move.w #0,count
        move.w #264,numba               ; We will send this many bytes later
        move.b #0,pstart
        bsr send_sfe                    ; Setup page writing
        lea secs(PC),a0
        move.l a0,table_addr
        move.w #4,numba
        bsr send_page                   ; Send start security code
        lea filenm(PC),a0
        move.l a0,table_addr
        move.w #8,numba
        bsr send_page                   ; Send file name
; Type determining code
        move.w size,d0
        add.w #1,d0
        move.l fileadr,a0
        adda d0,a0                      ; Get type byte
        move.b (a0),d1
        cmp.w #$DC,d1                   ; Program?
        beq prgm_type
        cmp.w #$E0,d1                   ; Text?
        beq text_type
        cmp.w #$2D,d1
        beq stng_type
        cmp.w #$DF,d1
        beq pict_type
        move.b #04,type                 ; We don't know what it is
        bra send_type
prgm_type:
        move.b #00,type
        bra send_type
text_type:
        move.b #01,type
        bra send_type
stng_type:
        move.b #02,type
        bra send_type
pict_type:
        move.b #03,type
send_type:
        lea type(PC),a0                 ; Send file type now
        move.l a0,table_addr
        move.w #1,numba
        bsr send_page           
        lea size(PC),a0                 ; Send file size
        move.l a0,table_addr
        move.w #2,numba
        bsr send_page
        addq.l #2,fileadr               ; Start of actual file data

; Fill the rest of this page with a file
send_rofpage:
        cmp.w #249,size                 ; More than 249 bytes to send?
        ble one_pagetot                 ; File will fit on one page
        move.w #249,numba               ; Send first 249 bytes of file
        move.l fileadr,table_addr
        bsr send_page                   ; That page is filled up
        add.l #249,fileadr              ; Point to first unsent byte
        sub.w #249,size                 ; Subtract 249 from file "size"
                                        ; size is really number of bytes left to send
        addq.w #1,page                  ; Advance to next page & initialize

big_file:
        move.w #15000,d7                ; Allow page to program
        bsr delay_loop
        cmp.w #260,size                 ; Can the rest of the file fit on one page or less?
        ble one_pagemore                ; Yes, it can
        move.w page,value+2
        bsr PrintVal
        WriteStr #10,#20,#4,buffer
        move.w size,value+2
        bsr PrintVal
        WriteStr #150,#20,#4,space
        WriteStr #150,#20,#4,buffer
        move.w #264,numba               ; We will send this many bytes later
        move.b #0,pstart
        bsr send_sfe                    ; Setup page writing
        move.w #4,numba                 ; Send the continued page security code
        lea secc(PC),a0
        move.l a0,table_addr
        bsr send_page
        move.w #260,numba               ; Send the next 260 bytes
        move.l fileadr,table_addr
        bsr send_page
        add.l #260,fileadr
        sub.w #260,size
        addq.w #1,page
        bra big_file

one_pagemore:
        move.w #264,numba               ; Setup this last page
        move.b #0,pstart
        bsr send_sfe
        move.w #4,numba                 ; Send the continued page security code
        lea secc(PC),a0
        move.l a0,table_addr
        bsr send_page
        move.w size,numba               ; Send the rest of the file
        move.l fileadr,table_addr
        bsr send_page
        move.w #4,d0                    ; Fill the rest of the page with $FF
        add.w size,d0
        move.w #264,d1
        sub.w d0,d1
        move.w d1,numba
        bsr erase_page
        WriteStr #100,#80,#4,filesnt
        bra exit_fsend
        
one_pagetot:
        move.w size,numba               ; Size is number of bytes to send
        move.l fileadr,table_addr       ; Beginning of file data
        bsr send_page
        move.w #15,d0                   ; Number of bytes we've sent
        add.w size,d0
        move.w #264,d1
        sub.w d0,d1                     ; Number of bytes we have left to pad
        move.w d1,numba
        bsr erase_page                  ; This will send the right number of pad FFs
        WriteStr #100,#80,#4,filesnt     ; Say that the file was sent
        bra exit_fsend

exit_fnf:
        WriteStr #10,#70,#4,fnf         ; file not found
        bra exit_fsend
exit_input:
        WriteStr #10,#70,#4,abortd
exit_fsend:
        bsr PutPaused
        bra exit_dir

; RECEIVE ROUTINES For Expander2
get_file:
        bsr ClearMenu
        bsr get_fname                   ; Get a file handle from user
; filenm is the file name we are sending
        cmp.w #1,d1
        beq exit_input
        cmp.w #0,f_handle               ; Did we get a match?
        bne already_on                  ; If we got a handle file exists!!
find_fname:                             ; Finds the page that that file starts at
        move.w #0,page
        WriteStr #10,#100,#4,scand
        WriteStr #150,#100,#4,oftot
        bsr PutBusy
ffn_loop:
        cmp.w #2048,page
        beq fname_not
        move.w page,value+2
        bsr PrintVal
        WriteStr #100,#100,#4,buffer
;        move.w #1,numba
;        move.b #0,pstart
;        lea fbyte(PC),a0
;        move.l a0,table_addr
;        bsr get_sfe                     ; Get first 4 characters
;        move.b fbyte,value+3            ; Display the byte we got
;        bsr PrintVal
;        WriteStr #210,#100,#4,buffer
        move.w #1,numba                 ; Check to see what kind of page this is
        move.b #3,pstart
        lea fbyte(PC),a0
        move.l a0,table_addr
        bsr get_sfe
        cmp.b #$FF,fbyte                ; Is the first byte a $FF?
        beq fname_not                   ; If it is, we found the first free page!
;        cmp.b #67,fbyte                ; This is the continuation of afile
;        beq skip_to_next2
        move.w #8,numba                 ; Get filename of that
        move.b #4,pstart
        lea buff2(PC),a0
        move.l a0,table_addr
        bsr get_sfe
;       WriteStr #150,#30,#4,space      ; Clear entry
;       WriteStr #10,#30,#4,filenm
;       WriteStr #150,#30,#4,buff2
;       bsr wait_key
        lea filenm(PC),a0
        lea buff2(PC),a1
        bsr cmp_eight
        cmp.w #1,d0			; Is this the file?
        beq page_found
	move.w #2,numba			; Get file size, put in size
        move.b #13,pstart
        lea size(PC),a0
        move.l a0,table_addr
        bsr get_sfe
	move.w size,d0
        cmp.w #249,d0                   ; Is file one page? if so, go to next p$
        ble skip_to_next2
        sub.w #249,d0                   ; Subtract number of bytes on this page
        move.w d0,d2
        divu #260,d0                    ; Divide file size by 260
        move.w d0,d1
        mulu #260,d1                    ; Test to see if division was even
        cmp.w d1,d2                     ; If so, d1=d2
        beq dont_need_one_more2
	addq.w #1,page
dont_need_one_more2:
	add.w d0,page
skip_to_next2:
        addq.w #1,page
        bra ffn_loop

fname_not:
        WriteStr #10,#80,#4,fnf         ; File not found!
        bsr PutPaused
        bra exit_dir                    ; Return

page_found:                             ; page is now first page of file
        move.w #2,numba                 ; Put file size into "size"
        move.b #13,pstart
        lea size(PC),a0
        move.l a0,table_addr
        bsr get_sfe
        clr.l d0
        move.w size,d0
        addq.w #2,d0                    ; Need room for size word
        move.l d0,-(a7)                 ; Push needed space to stack
        jsr tios::HeapAlloc             ; Try to make handle
        lea 4(a7),a7                    ; Update stack
        cmp.w #0,d0                     ; Did we get a handle or not?
        beq no_handle
	move.w #1,active_h		; Remember that we have an active
					; handle now so we can destroy if
					; receive fails
        move.w d0,table_handle          ; Store handle for later
        handle_ptr d0,a0                ; Get address to our space
        move.w size,(a0)                ; First word of a file is size
        adda #2,a0
        move.l a0,fileadr               ; Fileadr now *first byte of file

        cmp.w #249,size                 ; Size is now byte counter
        ble get_op                      ; Get the rest of this page, or less
        move.w #249,numba               ; Get the first 249 bytes
        move.b #15,pstart
        move.l fileadr,table_addr
        bsr get_sfe
; DEBUG CODE!
;        move.b #249,value+3            ; Display the byte we got
;        bsr PrintVal
;        WriteStr #50,#50,#4,buffer
; END DEBUG CODE
        add.l #249,fileadr              ; Point to next byte to send
        sub.w #249,size                 ; Subtract 249 from "counter"
        addq.w #1,page                  ; Increment to next page of file
get_more:
        cmp.w #260,size                 ; More than 260 bytes to send?
        ble get_onemore
        move.w page,value+2             ; Display various status info
        bsr PrintVal
        WriteStr #10,#20,#4,buffer
        move.w size,value+2
        bsr PrintVal
        WriteStr #150,#20,#4,space
        WriteStr #150,#20,#4,buffer
        move.w #260,numba               ; Get 260 bytes from this page
        move.b #4,pstart
        move.l fileadr,table_addr
        bsr get_sfe
        add.l #260,fileadr              ; Next free byte
        sub.w #260,size
        addq.w #1,page                  ; Next page of data, we're done here
        bra get_more                    ; Still more data coming

get_onemore:
        move.w size,numba
        move.b #4,pstart
        move.l fileadr,table_addr
        bsr get_sfe
        bra make_vat

get_op:
        move.w size,numba               ; Number of bytes to get
        move.b #15,pstart               ; Start of data
        move.l fileadr,table_addr
        bsr get_sfe
;        bra make_vat                    ; Make vat entry

make_vat:                               ; Make VAT entry using Gareth's code
;        move.w table_handle,d0
;        handle_ptr d0,a0
;        move.l a0,addr
;        bsr ClearScreen
;        bsr hmain_loop                  ; Launch hex viewer
        bsr add_vat                     ; Add a VAT entry (I hope)
        cmp.w #0,d0                     ; Did we have enough memory?
        beq no_handle                   ; Nope
;        bsr ClearScreen
        WriteStr #100,#80,#4,filerec    ; Received file correctly
	move.w #0,active_h		; Handle was used, so don't destroy
        bra exit_dir

no_handle:
        WriteStr #10,#80,#4,cantmk      ; Cannot make the handle
        bsr PutPaused
        bra exit_dir
